{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}



//{$WARN UNSAFE_TYPE ON}
//{$WARN UNSAFE_CODE ON}
//{$WARN UNSAFE_CAST ON}
// OD - Code du Livre D7 port sous Delphi.NET depuis projet Win32 VisualCLX

unit Unit1;

interface

uses
  SysUtils, Types, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBXpress, DB, SqlExpr, ExtCtrls, DBCtrls, Grids, DBGrids,
  Provider, DBClient, Buttons, FMTBcd, System.ComponentModel;

type
  TForm1 = class(TForm)
    DBNavigator1: TDBNavigator;
    Label1: TLabel;
    Edit1: TEdit;
    sbOpen: TSpeedButton;
    btnOuvrir: TButton;
    BtnFermer: TButton;
    BtnStartT: TButton;
    BtnCancelT: TButton;
    BtnValidT: TButton;
    btnAppliquer: TButton;
    SQLTable1: TSQLTable;
    DataSetProvider1: TDataSetProvider;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    OpenDialog1: TOpenDialog;
    DBGrid1: TDBGrid;
    SQLConnection1: TSQLConnection;
    procedure btnOuvrirClick(Sender: TObject);
    procedure BtnFermerClick(Sender: TObject);
    procedure BtnStartTClick(Sender: TObject);
    procedure BtnCancelTClick(Sender: TObject);
    procedure BtnValidTClick(Sender: TObject);
    procedure btnAppliquerClick(Sender: TObject);
    procedure sbOpenClick(Sender: TObject);
  private
    { Dclarations prives }
    TD : TTransactionDesc;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnOuvrirClick(Sender: TObject);
begin
 SQLConnection1.Params.values['database']:=edit1.text;
 SQLConnection1.Connected:=true;
 SQLTable1.Open;
 ClientDataSet1.Open;
 td.TransactionID := 1;
 td.IsolationLevel := xilREADCOMMITTED;
 SQLConnection1.StartTransaction(td);
end;

procedure TForm1.BtnFermerClick(Sender: TObject);
begin
 If SQLConnection1.InTransaction then
  if MessageDlg('Valider la transaction ?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
     SQLConnection1.Commit(td) else SQLConnection1.Rollback(td);
 ClientDataSet1.Close;
 SQLConnection1.Close;
end;

procedure TForm1.BtnStartTClick(Sender: TObject);
begin
 if not SQLConnection1.InTransaction then
  SQLConnection1.StartTransaction(td);
end;

procedure TForm1.BtnCancelTClick(Sender: TObject);
begin
 if SQLConnection1.InTransaction then
  SQLConnection1.Rollback(td);
end;

procedure TForm1.BtnValidTClick(Sender: TObject);
begin
 if SQLConnection1.InTransaction then
  SQLConnection1.Commit(td);
end;

procedure TForm1.btnAppliquerClick(Sender: TObject);
begin
 ClientDataSet1.ApplyUpdates(-1);
end;

procedure TForm1.sbOpenClick(Sender: TObject);
begin
 if OpenDialog1.Execute then
  Edit1.Text := OpenDialog1.FileName;
end;

end.
